#pragma once
#include <J3ML/LinearAlgebra/Vector4.hpp>
#include <J3ML/LinearAlgebra/Vector3.hpp>
#include <Color4.hpp>

namespace JGL {
    class Light;
    class OmnidirectionalLight2D;
    class PointLight2D;
}

class JGL::Light {
private:
    /// W in position seems to determine whether or not the light is omni-directional. 1 = omni 0 = point.
    /// Position is un-normalized screen space. For ex 500, 500, 1 for a light coming from where you're sitting.
    Vector4 position = {0, 0, 0, 1};
    Color4 ambient = {0, 0, 0, 0};
    Color4 diffuse = {0, 0, 0, 0};
    Color4 specular = {0, 0, 0, 0};
public:
    Light(const Vector3& position, const Color4& ambient, const Color4& diffuse, const Color4& specular);
    Vector3 GetNormalizedSceenSpaceCoordinates() const;
};

class JGL::OmnidirectionalLight2D {
private:
public:
    OmnidirectionalLight2D(const Vector3& position, const Color4& ambient, const Color4& diffuse, const Color4& specular);

};
